
%{
  #define YYSTYPE char const *
  #define yyfalse 0
  #define yytrue 1

  #include <ctype.h>
  #include <stdio.h>
  #include <string.h>
  int yylex (void);
  void yyerror (char const *);
%}

%glr-parser

%%

command:
  's' var 't'
  { fprintf (stderr, "Statement variable: '%s' (%p)\n", $2, $2);
  } 'v'
  | 's' var_list 't' 'e'
  { fprintf (stderr, "Statement varlist: '%s' (%p)\n", $2, $2);
  }
  ;

var:
  'V'
  { $$ = strdup ("VARIABLE");
    fprintf (stderr, "Variable: created '%s' (%p)\n", $$, $$);
  }
  ;

var_list:
  var
  { $$ = $1;
    fprintf (stderr, "Varlist: passing '%s' (%p)\n", $1, $1);
  }
  | var ',' var_list
  ;

%%

FILE *yyin = NULL;

int
yylex (void)
{ int c;
  char buf[50];
  while ((c = fgetc (yyin)) == ' ' || c == '\t' || c == '\n') ;
  if (c == EOF) return 0;
  buf[0] = c;
  buf[1] = 0;
  yylval = strdup (buf);
  return c;
}

void
yyerror (char const *s)
{ printf ("%s\n", s);
}

int
main (int argc, char **argv)
{ yyin = stdin;
  if (argc == 2 && !(yyin = fopen (argv[1], "r"))) return 1;
  return yyparse ();
}
